#pragma once
#include "mbed.h"
#include "QT1070.h"

namespace QT1070touchemulator
{

    enum Qt1070Register {
        CHIP_ID = 0,
        FIRMWARE = 1,
        KEY_STATUS = 3,
        RESET = 57
    };

    class I2cQT1070 : public I2CSlave
    {
    public:
        I2cQT1070(PinName sda, PinName scl, int address=0xDE, int frequentie = 100);
        void check_for_instruction(void);
        void save_register_adress(void);
    
    private:
        QT1070 Qt1070Chip;
        int registerAdress;
        int read_data(void);
        void send_data_to_master(void);
        void process_instruction(void);
    };
};